Subject: Re: Broken asm/div64.h macro

From: Tom Rini <[email-masked]>
Date: Tue, 29 Jan 2002 08:01:13 -0700

On Tue, Jan 29, 2002 at 02:05:28PM +0900, Kaoru Fukui wrote:
> On 28 Jan, Tom Rini wrote:
> > On Mon, Jan 28, 2002 at 08:45:31PM +0100, Geert Uytterhoeven wrote:
> >> On Mon, 28 Jan 2002, Tom Rini wrote:
> >> > On Mon, Jan 28, 2002 at 10:16:28AM +0200, Momchil Velikov wrote:
> >> > > >>>>> "Kaoru" == Kaoru Fukui <[email-masked]> writes:
> >> > >
> >> > > Kaoru> On 27 Jan, Troy Benjegerdes wrote:
> >> > > >> Did you actually try compiling PPC this way??
> >> > > >>
> >> > > >> vsprintf.o(.text+0x494): undefined reference to `__umoddi3'
> >> > > >> vsprintf.o(.text+0x494): relocation truncated to fit: R_PPC_REL24
> >> > > >> __umoddi3
> >> > > >> vsprintf.o(.text+0x4ac): undefined reference to `__udivdi3'
> >> > > >> vsprintf.o(.text+0x4ac): relocation truncated to fit: R_PPC_REL24
> >> > > >> __udivdi3
> >> > >
> >> > > Kaoru> libgcc.a has those libraries.
> >> > >
> >> > > Yeah, but we don't link with libgcc.a. (which I forgot).
> >> >
> >> > Er, but isn't it (sort-of) considered a bug if the kernel links with
> >> > libgcc.a ?  I think the consensious on l-k would be yes.
> >>
> >> So you copy the code from the libgcc sources, cfr. arch/m68k/lib/.
> >
> > Or optimize that, yes.  But linking directly is a no-no. :)
>
> Yes,it's should has the source in the kernel.
>
> However,the other archies(arm,cris,sh) use libgcc.a with static
> link.
> Those makefiles have
> LIBGCC  := $(shell $(CC) $(CFLAGS) --print-libgcc-file-name)

ARM doesn't do this anymore, since it required having the correct target
libgcc around.  SH is planning on moving away from this in 2.5.x from
what I understand.

> If it's static link, it is same result isn't it?

Sort of.  It depends on a certain libgcc, which is bad.

--
Tom Rini (TR1265)
http://gate.crashing.org/~trini/

** Sent via the linuxppc-dev mail list. See http://lists.linuxppc.org/